/*
Name      ZAPCHK
Author    BF Gavin, CompuDox
Format    Standard .EXE file format.
Intent    Patch CHKDSK.EXE v6.2x to not display SCANDISK hype message.

Model     COMPACT
Compiler  Borland C v3.1, all warnings enabled.
          Make -B -f zapchk.mak

Usage     No command line parms.
07DEC93   Release date
17DEC94   Update for 6.22 (no change in logic or address)

Needs     CHKDSK.EXE in the default directory.
          Must use PKLITE -x to unpack CHKDSK.EXE first.

Method    Calls to SCANDISK advertising message are NOP'd out.
          Carry flag for CHKDSK /F hard coded to NC (yes).
*/





/*  */
/*                                Header Files                               */
/*  */
#include <alloc.h>;                             // farcalloc
#include <conio.h>;                             // clrscr
#include <dir.h>;                               // findfirst, ffblk
#include <io.h>;                                // _chmod
#include <stdio.h>;                             // printf
#include <stdlib.h>;                            // exit





/*  */
/*                              Global Variables                             */
/*  */
FILE
  *handle;                                      // file handle

unsigned long int
  FilePos,
  Addr620 = 0x3A38L,                            // patch offset in v6.20
  Addr622 = 0x3A38L;                            // patch offset in v6.22

unsigned char
  Old620 [17] = {
                0xE8, 0xF9, 0x04,               // Call CHKDSK /F message
                0x72, 0x09,                     // Jc   37D6 - skip chkdsk
                0xE8, 0xF6, 0x03,               // ChkDsk program calls
                0xE8, 0x10, 0x04,               //   ..
                0xE8, 0x14, 0x04,               //   ..
                0xE8, 0xCE, 0x04                // Call SCANDISK hype message
                };

unsigned char
  New620 [17] = {
                0x90, 0x90, 0x90,               // NOP  the message call
                0x90, 0xF8,                     // CLC  always return 'YES'
                0xE8, 0xF6, 0x03,               // ChkDsk program calls
                0xE8, 0x10, 0x04,
                0xE8, 0x14, 0x04,
                0x90, 0x90, 0x90                // NOP  the message call
                };

unsigned char
  Old622 [17] = {
                0xE8, 0xF9, 0x04,               // Call CHKDSK /F message
                0x72, 0x09,                     // Jc   37D6 - skip chkdsk
                0xE8, 0xF6, 0x03,               // ChkDsk program calls
                0xE8, 0x10, 0x04,               //   ..
                0xE8, 0x14, 0x04,               //   ..
                0xE8, 0xCE, 0x04                // Call SCANDISK hype message
                };

unsigned char
  New622 [17] = {
                0x90, 0x90, 0x90,               // NOP  the message call
                0x90, 0xF8,                     // CLC  always return 'YES'
                0xE8, 0xF6, 0x03,               // ChkDsk program calls
                0xE8, 0x10, 0x04,
                0xE8, 0x14, 0x04,
                0x90, 0x90, 0x90                // NOP  the message call
                };

unsigned int
  Crc16 [256] = {
                0x0000, 0xC0C1, 0xC181, 0x0140,
                0xC301, 0x03C0, 0x0280, 0xC241,
                0xC601, 0x06C0, 0x0780, 0xC741,
                0x0500, 0xC5C1, 0xC481, 0x0440,
                0xCC01, 0x0CC0, 0x0D80, 0xCD41,
                0x0F00, 0xCFC1, 0xCE81, 0x0E40,
                0x0A00, 0xCAC1, 0xCB81, 0x0B40,
                0xC901, 0x09C0, 0x0880, 0xC841,
                0xD801, 0x18C0, 0x1980, 0xD941,
                0x1B00, 0xDBC1, 0xDA81, 0x1A40,
                0x1E00, 0xDEC1, 0xDF81, 0x1F40,
                0xDD01, 0x1DC0, 0x1C80, 0xDC41,
                0x1400, 0xD4C1, 0xD581, 0x1540,
                0xD701, 0x17C0, 0x1680, 0xD641,
                0xD201, 0x12C0, 0x1380, 0xD341,
                0x1100, 0xD1C1, 0xD081, 0x1040,
                0xF001, 0x30C0, 0x3180, 0xF141,
                0x3300, 0xF3C1, 0xF281, 0x3240,
                0x3600, 0xF6C1, 0xF781, 0x3740,
                0xF501, 0x35C0, 0x3480, 0xF441,
                0x3C00, 0xFCC1, 0xFD81, 0x3D40,
                0xFF01, 0x3FC0, 0x3E80, 0xFE41,
                0xFA01, 0x3AC0, 0x3B80, 0xFB41,
                0x3900, 0xF9C1, 0xF881, 0x3840,
                0x2800, 0xE8C1, 0xE981, 0x2940,
                0xEB01, 0x2BC0, 0x2A80, 0xEA41,
                0xEE01, 0x2EC0, 0x2F80, 0xEF41,
                0x2D00, 0xEDC1, 0xEC81, 0x2C40,
                0xE401, 0x24C0, 0x2580, 0xE541,
                0x2700, 0xE7C1, 0xE681, 0x2640,
                0x2200, 0xE2C1, 0xE381, 0x2340,
                0xE101, 0x21C0, 0x2080, 0xE041,
                0xA001, 0x60C0, 0x6180, 0xA141,
                0x6300, 0xA3C1, 0xA281, 0x6240,
                0x6600, 0xA6C1, 0xA781, 0x6740,
                0xA501, 0x65C0, 0x6480, 0xA441,
                0x6C00, 0xACC1, 0xAD81, 0x6D40,
                0xAF01, 0x6FC0, 0x6E80, 0xAE41,
                0xAA01, 0x6AC0, 0x6B80, 0xAB41,
                0x6900, 0xA9C1, 0xA881, 0x6840,
                0x7800, 0xB8C1, 0xB981, 0x7940,
                0xBB01, 0x7BC0, 0x7A80, 0xBA41,
                0xBE01, 0x7EC0, 0x7F80, 0xBF41,
                0x7D00, 0xBDC1, 0xBC81, 0x7C40,
                0xB401, 0x74C0, 0x7580, 0xB541,
                0x7700, 0xB7C1, 0xB681, 0x7640,
                0x7200, 0xB2C1, 0xB381, 0x7340,
                0xB101, 0x71C0, 0x7080, 0xB041,
                0x5000, 0x90C1, 0x9181, 0x5140,
                0x9301, 0x53C0, 0x5280, 0x9241,
                0x9601, 0x56C0, 0x5780, 0x9741,
                0x5500, 0x95C1, 0x9481, 0x5440,
                0x9C01, 0x5CC0, 0x5D80, 0x9D41,
                0x5F00, 0x9FC1, 0x9E81, 0x5E40,
                0x5A00, 0x9AC1, 0x9B81, 0x5B40,
                0x9901, 0x59C0, 0x5880, 0x9841,
                0x8801, 0x48C0, 0x4980, 0x8941,
                0x4B00, 0x8BC1, 0x8A81, 0x4A40,
                0x4E00, 0x8EC1, 0x8F81, 0x4F40,
                0x8D01, 0x4DC0, 0x4C80, 0x8C41,
                0x4400, 0x84C1, 0x8581, 0x4540,
                0x8701, 0x47C0, 0x4680, 0x8641,
                0x8201, 0x42C0, 0x4380, 0x8341,
                0x4100, 0x81C1, 0x8081, 0x4040
                };





/*  */
/*                            Function Prototypes                            */
/*  */
unsigned int GetFileCrc(void);
void PatchFile (unsigned int _crc);





/*  */
/*                         Calculate File CRC16 Value                        */
/*  */
unsigned int GetFileCrc(void)
  {
  struct ffblk
    dta;

  unsigned int
    idx,
    crc;

  unsigned char
    *heapptr;

  if (!findfirst ("CHKDSK.EXE",&dta,0x20)==0)
     {
     printf ("\nThis program patches CHKDSK.EXE to remove the SCANDISK messages.\n");
     printf ("CHKDSK.EXE was not found in the default directory\n\n");
     exit(1);
     }

   if ((heapptr = farcalloc(dta.ff_fsize,(long)sizeof(char)))==NULL)
      {
      printf ("Insufficient heap space to load CHKDSK.EXE file\n\n");
      exit(1);
      }

  _chmod("CHKDSK.EXE",1,0x00);                  // insure file not read-only

  if ((handle = fopen("CHKDSK.EXE","r+b")) == NULL)
     {
     printf ("Unable to open CHKDSK.EXE for read/write access\n\n");
     exit(1);                                   // exit with ERRORLEVEL set
     }

  fread (heapptr,1,(unsigned int)dta.ff_fsize,handle);

  idx = 0;                                      // file data index
  crc = 0;                                      // pre-condition CRC value to 0
  for (idx=0;idx < (unsigned int) dta.ff_fsize;idx++)
      crc  = (crc >> 8) ^ Crc16[(heapptr[idx]) ^ (crc & 0x00ff)];

  return crc;                                   // CRC determines version
  }





/*  */
/*                           Patch CHKDSK.EXE File                           */
/*  */
void PatchFile (unsigned int _crc)
  {
  unsigned int
    OK,                                         // signature compare flag
    idx;

  unsigned long int
    seekaddr;

  unsigned char
    *oldptr,
    *newptr;

  unsigned char
    buffer [17];                               // disk read buffer

  switch (_crc)                                // size determines version
         {

         case 0xF28E:                          // v6.00 compressed with PKLITE
              {
              printf ("\nCHKDSK v6.00 does not require this patch.\n");
              exit(1);
              }

         case 0x5123:                          // v6.00 expanded
              {
              printf ("\nCHKDSK v6.00 does not require this patch.\n");
              exit(1);
              }

         case 0x5383:                           // v6.20 compressed with PKLITE
              {
              printf ("\nCHKDSK v6.20 is still compressed.  Use PKLITE -x to expand it\n");
              exit(1);
              }

         case 0xBCA4:                           // v6.22 compressed with PKLITE
              {
              printf ("\nCHKDSK v6.22 is still compressed.  Use PKLITE -x to expand it\n");
              exit(1);
              }

         case 0x8897:                           // v6.20 already patched
              {
              printf ("\nCHKDSK v6.20 is already patched.\n");
              exit(1);
              }

         case 0x4F07:                           // v6.22 already patched
              {
              printf ("\nCHKDSK v6.22 is already patched.\n");
              exit(1);
              }

         case 0x5EFC:                           // v6.20 expanded, unpatched
              {
              oldptr   = &Old620[0];
              newptr   = &New620[0];
              seekaddr = Addr620;
              break;
              }

         case 0x996C:                           // v6.22 expanded, unpatched
              {
              oldptr   = &Old622[0];
              newptr   = &New622[0];
              seekaddr = Addr622;
              break;
              }

         default:
              {
              printf ("File CRC16 verify failed.  Unable to patch CHKDSK.EXE\n");
              exit(1);
              }
         }                                      // end switch

  fseek (handle,seekaddr,SEEK_SET);             // seek to CHKDSK patch area
  fread (buffer,17,sizeof(char),handle);        // read patch area
  OK = 0;                                       // clear the flag
  for (idx=0;idx<17;idx++)                      // scan signature
      if (oldptr[idx] != buffer[idx])           // signature non-compare?
         OK++;                                  // y: inc flag to non-zero

  if (OK == 0)                                  // file match signature?
     {                                          // y: ok to patch the file
     fseek (handle,seekaddr,SEEK_SET);          // seek back to patch address
     fwrite (newptr,17,sizeof(char),handle);    // write patch data to CHKDSK.EXE
     printf("CHKDSK.EXE is patched.\n");        // display success message
     printf("The SCANDISK advertising messages will no longer display.\n");
     }
  else
     printf ("Signature verify failed.  Unable to patch CHKDSK.EXE\n");
  }





/*  */
/*                                    Main                                   */
/*  */
void main()
  {
  unsigned int
    crc;

  clrscr();                                     // clear the screen
  printf ("\nPatch file courtesy CompuDox Onsite Computer Support\n");
  crc = GetFileCrc();                           // find CHKDSK.EXE file CRC-16
  PatchFile (crc);                              // file CRC determines version
  fclose(handle);                               // close CHKDSK.EXE file
  printf ("\n");                                // trailing CRLF
  exit (0);                                     // return errorlevel 0 or 1
  }
